package cn.iocoder.yudao.module.system.enums.sms;

import cn.hutool.core.util.ArrayUtil;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 用户短信验证码发送场景的枚举
 *
 * @author 捷道源码
 */
@Getter
@AllArgsConstructor
public enum SmsNodeEnum {

    MEMBER_REG("user-sms-reg", "user-sms-reg", "会员用户 - 手机号注册"),//测了

    MEMBER_LOGIN("user-sms-login", "user-sms-login", "会员用户 - 手机号登陆"),//测了

    MEMBER_UPDATE_MOBILE("user-sms-update-mobile", "user-sms-update-mobile", "会员用户 - 解绑手机"),//测了

    MEMBER_FORGET_PASSWORD("user-sms-reset-password", "user-sms-reset-password", "会员用户 - 忘记密码"),//测了

    TRANSFER_CONTROL_GOODS("transfer-control-goods", "transfer-control-goods", "订单 - 控货权转移"),//测了

    DELIVERY_VERIFICATION_SMS("delivery-verification-sms", "delivery-verification-sms", "订单 - 放货验证短信"),//测了


    NOTIFICATION_SUCCESS_DELIVERY("notification-successful-delivery", "notification-successful-delivery", "订单 - 放货成功通知"),//测了
    NOTIFICATION_SUCCESS_CANCEL_DELIVERY("notification-successful-cancel-delivery", "notification-successful-cancel-delivery", "订单 - 取消放货通知"),//测了
//    NOTIFICATION_SUCCESS_SEASONING_CONDIMENTS("notification-successful-seasoning-condiments", "notification-successful-seasoning-condiments", "订单 - 调货通知"),//暂时没发现调用

    MEMBER_REDEEM_REWARD("user-sms-redeem-reward", "user-sms-redeem-reward", "会员用户 - 兑换礼品"),


//    SHIPMENT_ARRIVALS("shipment-arrivals", "shipment-arrivals", "出货 - 到港通知(多订单)"),//
//    SHIPMENT_CUSTOMS_CLEARANCES("shipment-customs-clearances", "shipment-customs-clearances", "出货 - 清关通知(多订单)"),//
//    SHIPMENT_CABINETS("shipment-cabinets", "shipment-cabinets", "出货 - 装柜通知(多订单)"),//
    SHIPMENT_ARRIVAL("shipment-arrival", "shipment-arrival", "出货 - 到港通知"),//h
    SHIPMENT_CUSTOMS_CLEARANCE("shipment-customs-clearance", "shipment-customs-clearance", "出货 - 清关通知"),//h
    SHIPMENT_CABINET("shipment-cabinet", "shipment-cabinet", "出货 - 装柜通知"),//h
    SHIPMENT_CLOSE_CONTAINER("shipment-close-container", "shipment-close-container", "出货 - 封柜反审"),//好像没发信息

    WAREHOUSE_IN_CONTROL("warehouse-in-control", "warehouse-in-control", "入仓控货通知"),//h
    WAREHOUSE_IN("warehouse-in", "warehouse-in", "入仓通知"),//h
    WAREHOUSE_IN_APPEND("warehouse-in-append", "warehouse-in-append", "追加通知"),//k
    WAREHOUSE_IN_CONTROL_COLLECT_OF_GOODS("warehouse-in-control-collect-of-goods", "warehouse-in-control-collect-of-goods", "入仓-控货代收货款"),//无此功能
    WAREHOUSE_IN_COLLECT_OF_GOODS("warehouse-in-collect-of-goods", "warehouse-in-collect-of-goods", "入仓-非控货代收货款"),//h


    /** 空运新增模板 **/

//    AIR_WAREHOUSE_IN_CONTROL("air-warehouse-in-control", "air-warehouse-in-control", "入仓控货通知"),//x

//    AIR_WAREHOUSE_IN("air-warehouse-in", "air-warehouse-in", "入仓通知"),//x

//    AIR_SHIPMENT_ARRIVAL("air-shipment-arrival", "air-shipment-arrival", "出货 - 到港通知"),//x
//    AIR_SHIPMENT_ARRIVALS("air-shipment-arrivals", "air-shipment-arrivals", "出货 - 到港通知(多订单)"),//x
//    AIR_SHIPMENT_CUSTOMS_CLEARANCE("air-shipment-customs-clearance", "air-shipment-customs-clearance", "出货 - 清关通知"),//
//    AIR_SHIPMENT_CUSTOMS_CLEARANCES("air-shipment-customs-clearances", "air-shipment-customs-clearances", "出货 - 清关通知(多订单)"),//

    AIR_SHIPMENT_WAREHOUSE("air-shipment-warehouse", "air-shipment-warehouse", "出货 - 出仓通知"),//
//    AIR_SHIPMENT_WAREHOUSES("air-shipment-warehouses", "air-shipment-warehouses", "出货 - 出仓通知(多订单)"),//

//    AIR_WAREHOUSE_IN_COLLECT_OF_GOODS("air-warehouse-in-collect-of-goods", "air-warehouse-in-collect-of-goods", "入仓-非控货代收货款"),//
    ;


    /**
     * 验证场景的编号
     */
    private final String nodeValue;
    /**
     * 模版编码
     */
    private final String templateCode;
    /**
     * 描述
     */
    private final String description;

    public static SmsNodeEnum getCodeByScene(String scene) {
        return ArrayUtil.firstMatch(sceneEnum -> sceneEnum.getNodeValue().equals(scene),
                values());
    }

}
