package cn.iocoder.yudao.module.system.controller.admin.sms.vo.smsNode;

import lombok.*;

import java.util.*;

import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
 * 短信节点 Response VO
 *
 * @author jayden
 */
@Data
@ApiModel("管理后台 - 短信节点 Response VO")
public class SmsNodeBackVO {

    @ExcelProperty("编号")
    @ApiModelProperty(value = "编号", required = true)
    private Long id;

    @ExcelProperty("节点")
    @ApiModelProperty(value = "节点", required = true)
    private String nodeValue;

    @ExcelProperty(value = "运输方式", converter = DictConvert.class)
    @DictFormat("transport_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    @ApiModelProperty(value = "运输方式", required = true)
    private Long transportId;

    @ExcelProperty("国家区号")
    @ApiModelProperty(value = "国家区号", required = true)
    private Long countryId;

    @ExcelProperty("国家区号")
    @ApiModelProperty(value = "国家区号，和订单中国家区号保持一致", required = true)
    private String countryCode;

    @ExcelProperty("启用状态")
    @ApiModelProperty(value = "启用状态(0：启用，1：关闭)", required = true)
    private Integer status;

    @ExcelProperty("模板1")
    @ApiModelProperty(value = "模板1", required = true)
    private Long templateIdOne;

    @ExcelProperty("模板2")
    @ApiModelProperty(value = "模板2")
    private Long templateIdTwo;

    @ExcelProperty("模板3")
    @ApiModelProperty(value = "模板3")
    private Long templateIdThree;

    @ExcelProperty("模板4")
    @ApiModelProperty(value = "模板4")
    private Long templateIdFour;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ExcelProperty("是否匹配运输方式")
    @ApiModelProperty(value = "是否匹配运输方式", required = true)
    private Integer isTransport;

    @ExcelProperty("多订单")
    @ApiModelProperty(value = "多订单", required = true)
    private Integer isOrders;
}
