package cn.iocoder.yudao.module.system.controller.admin.sms.vo.smsNode;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ApiModel("管理后台 - 短信节点查询 VO")
public class SmsNodeQueryVO {

    @ApiModelProperty(value = "节点")
    private String nodeValue;

    @ApiModelProperty(value = "运输方式ID")
    private Long transportId;

    @ApiModelProperty(value = "国家区号id")
    private Long countryId;

    @ApiModelProperty(value = "国家区号，和订单中国家区号保持一致")
    private String countryCode;

    @ApiModelProperty(value = "启用状态(0：启用，1：关闭)")
    private Integer status;

    @ApiModelProperty(value = "模板1")
    private Long templateIdOne;

    @ApiModelProperty(value = "模板2")
    private Long templateIdTwo;

    @ApiModelProperty(value = "模板3")
    private Long templateIdThree;

    @ApiModelProperty(value = "模板4")
    private Long templateIdFour;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

    @ApiModelProperty(value = "是否匹配运输方式", required = true)
    private Integer isTransport;

    @ApiModelProperty(value = "多订单", required = true)
    private Integer isOrders;
}
