package cn.iocoder.yudao.module.system.dal.mysql.sms;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.system.controller.admin.sms.vo.smsNode.SmsNodeQueryVO;
import cn.iocoder.yudao.module.system.dal.dataobject.sms.SmsNodeDO;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 短信节点 Mapper
 *
 * @author jayden
 */
@Mapper
public interface SmsNodeMapper extends AbstractMapper<SmsNodeDO> {
    @Override
    default PageResult<SmsNodeDO> selectPage(PageVO page, Object object) {
        if (object instanceof SmsNodeQueryVO) {
            SmsNodeQueryVO vo = (SmsNodeQueryVO) object;
            return selectPage(page, new LambdaQuery<SmsNodeDO>()
                    .eq(StringUtils.isNotBlank(vo.getNodeValue()), SmsNodeDO::getNodeValue, vo.getNodeValue())
                    .eqIfPresent(SmsNodeDO::getTransportId, vo.getTransportId())
                    .eqIfPresent(SmsNodeDO::getCountryId, vo.getCountryId())
                    .eqIfPresent(SmsNodeDO::getCountryCode, vo.getCountryCode())
                    .eqIfPresent(SmsNodeDO::getIsTransport, vo.getIsTransport())
                    .eqIfPresent(SmsNodeDO::getIsOrders, vo.getIsOrders())
                    .eqIfPresent(SmsNodeDO::getStatus, vo.getStatus())
                    .eqIfPresent(SmsNodeDO::getTemplateIdOne, vo.getTemplateIdOne())
                    .eqIfPresent(SmsNodeDO::getTemplateIdTwo, vo.getTemplateIdTwo())
                    .eqIfPresent(SmsNodeDO::getTemplateIdThree, vo.getTemplateIdThree())
                    .eqIfPresent(SmsNodeDO::getTemplateIdFour, vo.getTemplateIdFour())
                    .betweenIfPresent(SmsNodeDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(SmsNodeDO::getId));
        }

        return null;
    }

    @Override
    default List<SmsNodeDO> selectList(Object object) {
        if (object instanceof SmsNodeQueryVO) {
            SmsNodeQueryVO vo = (SmsNodeQueryVO) object;
            return selectList(new LambdaQuery<SmsNodeDO>()
                    .eq(StringUtils.isNotBlank(vo.getNodeValue()), SmsNodeDO::getNodeValue, vo.getNodeValue())
                    .eqIfPresent(SmsNodeDO::getTransportId, vo.getTransportId())
                    .eqIfPresent(SmsNodeDO::getCountryId, vo.getCountryId())
                    .eqIfPresent(SmsNodeDO::getCountryCode, vo.getCountryCode())
                    .eqIfPresent(SmsNodeDO::getIsTransport, vo.getIsTransport())
                    .eqIfPresent(SmsNodeDO::getIsOrders, vo.getIsOrders())
                    .eqIfPresent(SmsNodeDO::getStatus, vo.getStatus())
                    .eqIfPresent(SmsNodeDO::getTemplateIdOne, vo.getTemplateIdOne())
                    .eqIfPresent(SmsNodeDO::getTemplateIdTwo, vo.getTemplateIdTwo())
                    .eqIfPresent(SmsNodeDO::getTemplateIdThree, vo.getTemplateIdThree())
                    .eqIfPresent(SmsNodeDO::getTemplateIdFour, vo.getTemplateIdFour())
                    .betweenIfPresent(SmsNodeDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(SmsNodeDO::getId));
        }

        return null;
    }
}
